<?php

//  $Id: product_links_export.php by luhui0512@sina.com http://zencart.kuaizhanbao.com   2010-03-24  $

  require('includes/application_top.php');


function zen_get_info_page($zf_product_id) {
    global $db;
    $sql = "select products_type from " . TABLE_PRODUCTS . " where products_id = '" . (int)$zf_product_id . "'";
    $zp_type = $db->Execute($sql);
    if ($zp_type->RecordCount() == 0) {
      return 'product_info';
    } else {
      $zp_product_type = $zp_type->fields['products_type'];
      $sql = "select type_handler from " . TABLE_PRODUCT_TYPES . " where type_id = '" . (int)$zp_product_type . "'";
      $zp_handler = $db->Execute($sql);
      return $zp_handler->fields['type_handler'] . '_info';
    }
  }
  

  function GetFullcPath($cID){
    global $db;
    static $parent_cache = array();
    $cats = array();
    $cats[] = $cID;
    $parent = $db->Execute("SELECT parent_id, categories_id
                            FROM " . TABLE_CATEGORIES . "
                            WHERE categories_id=" . (int)$cID);
    while(!$parent->EOF && $parent->fields['parent_id'] != 0) {
      $parent_cache[(int)$parent->fields['categories_id']] = (int)$parent->fields['parent_id'];
      $cats[] = $parent->fields['parent_id'];
      if(isset($parent_cache[(int)$parent->fields['parent_id']])) {
        $parent->fields['parent_id'] = $parent_cache[(int)$parent->fields['parent_id']];
      } else {
        $parent = $db->Execute("SELECT parent_id, categories_id
                                FROM " . TABLE_CATEGORIES . "
                                WHERE categories_id=" . (int)$parent->fields['parent_id']);
      }
    }
    $cats = array_reverse($cats);
    $cPath = implode('_', $cats);
    return $cPath;
  }
  
  
 function get_link($page = '', $parameters = '', $connection = 'NONSSL', $add_session_id = true, $search_engine_safe = true, $static = false, $use_dir_ws_catalog = true) {
		
		/* QUICK AND DIRTY WAY TO DISABLE REDIRECTS ON PAGES WHEN SEO_URLS_ONLY_IN is enabled IMAGINADW.COM */
		$sefu = explode(",", ereg_replace( ' +', '', SEO_URLS_ONLY_IN ));
		if((SEO_URLS_ONLY_IN!="") && !in_array($page,$sefu)) {
			return original_get_link($page, $parameters, $connection, $add_session_id, $search_engine_safe, $static, $use_dir_ws_catalog);
		}
		
		if (!isset($GLOBALS['seo_urls']) && !is_object($GLOBALS['seo_urls'])) {
			include_once(DIR_FS_CATALOG . 'includes/classes/seo.url.php');

			$GLOBALS['seo_urls'] = &new SEO_URL($_SESSION['languages_id']);
		}

		return $GLOBALS['seo_urls']->href_link($page, $parameters, $connection, $add_session_id, $static, $use_dir_ws_catalog);
  }
 

  function original_get_link($page = '', $parameters = '', $connection = 'NONSSL', $add_session_id = true, $search_engine_safe = true, $static = false, $use_dir_ws_catalog = true) {
    global $request_type, $session_started, $http_domain, $https_domain;

    if (!zen_not_null($page)) {
      die('</td></tr></table></td></tr></table><br /><br /><strong class="note">Error!<br /><br />Unable to determine the page link!</strong><br /><br /><!--' . $page . '<br />' . $parameters . ' -->');
    }

    if ($connection == 'NONSSL') {
      $link = HTTP_SERVER;
    } elseif ($connection == 'SSL') {
      if (ENABLE_SSL == 'true') {
        $link = HTTPS_SERVER ;
      } else {
        $link = HTTP_SERVER;
      }
    } else {
      die('</td></tr></table></td></tr></table><br /><br /><strong class="note">Error!<br /><br />Unable to determine connection method on a link!<br /><br />Known methods: NONSSL SSL</strong><br /><br />');
    }

    if ($use_dir_ws_catalog) {
      if ($connection == 'SSL' && ENABLE_SSL == 'true') {
        $link .= DIR_WS_HTTPS_CATALOG;
      } else {
        $link .= DIR_WS_CATALOG;
      }
    }

    if (!$static) {
      if (zen_not_null($parameters)) {
        $link .= 'index.php?main_page='. $page . "&" . zen_output_string($parameters);
      } else {
        $link .= 'index.php?main_page=' . $page;
      }
    } else {
      if (zen_not_null($parameters)) {
        $link .= $page . "?" . zen_output_string($parameters);
      } else {
        $link .= $page;
      }
    }

    $separator = '&';

    while ( (substr($link, -1) == '&') || (substr($link, -1) == '?') ) $link = substr($link, 0, -1);
// Add the session ID when moving from different HTTP and HTTPS servers, or when SID is defined
    if ( ($add_session_id == true) && ($session_started == true) && (SESSION_FORCE_COOKIE_USE == 'False') ) {
      if (defined('SID') && zen_not_null(SID)) {
        $sid = SID;
//      } elseif ( ( ($request_type == 'NONSSL') && ($connection == 'SSL') && (ENABLE_SSL_ADMIN == 'true') ) || ( ($request_type == 'SSL') && ($connection == 'NONSSL') ) ) {
      } elseif ( ( ($request_type == 'NONSSL') && ($connection == 'SSL') && (ENABLE_SSL == 'true') ) || ( ($request_type == 'SSL') && ($connection == 'NONSSL') ) ) {
        if ($http_domain != $https_domain) {
          $sid = zen_session_name() . '=' . zen_session_id();
        }
      }
    }

// clean up the link before processing
    while (strstr($link, '&&')) $link = str_replace('&&', '&', $link);
    while (strstr($link, '&amp;&amp;')) $link = str_replace('&amp;&amp;', '&amp;', $link);

    if ( (SEARCH_ENGINE_FRIENDLY_URLS == 'true') && ($search_engine_safe == true) ) {
      while (strstr($link, '&&')) $link = str_replace('&&', '&', $link);

      $link = str_replace('&amp;', '/', $link);
      $link = str_replace('?', '/', $link);
      $link = str_replace('&', '/', $link);
      $link = str_replace('=', '/', $link);

      $separator = '?';
    }

    if (isset($sid)) {
      $link .= $separator . zen_output_string($sid);
    }

// clean up the link after processing
    while (strstr($link, '&amp;&amp;')) $link = str_replace('&amp;&amp;', '&amp;', $link);

    $link = ereg_replace('&', '&amp;', $link);
    return $link;
  }
  
  

  $action = (isset($_GET['action']) ? $_GET['action'] : '');
  $NL="
"; // NOTE: The line break above is INTENTIONAL!

  $available_export_formats[0]=array('id' => '0', 'text' => 'CSV');
  $available_export_formats[1]=array('id' => '1', 'text' => 'TXT');
  $save_to_file_checked=(isset($_POST['savetofile']) && zen_not_null($_POST['savetofile']) ? $_POST['savetofile'] : 0 );
  $post_format = (isset($_POST['format']) && zen_not_null($_POST['format']) ? $_POST['format'] : 1 );
  $format = $available_export_formats[$post_format]['text'];
  $file = (isset($_POST['filename']) ? $_POST['filename'] : 'productlinks.txt');

  if ($action != '') {
    switch ($action) {
      case 'save':
      global $db;

  if ($format =='CSV') {
    $FIELDSTART = '"';
    $FIELDEND = '"';
    $FIELDSEPARATOR = ',';
    $LINESTART = '';
    $LINEBREAK = "\n";
  }
  if ($format =='TXT') {
    $FIELDSTART = '<a href="';
    $FIELDEND = '>';
    $FIELDSEPARATOR = '';
    $LINESTART = '';
    $LINEBREAK = '</a>'."\n";
  }


       if (isset($_POST['audience_selected'])) {
          $query_name=$_POST['audience_selected'];
      }
	  
	  if($query_name==2){
      $query_string = "SELECT p.products_id,pd.products_name, GREATEST(p.products_date_added, IFNULL(p.products_last_modified, 0)) AS last_date, p.products_ordered, l.code FROM " . TABLE_PRODUCTS . " p LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " pd ON (p.products_id = pd.products_id)
                                LEFT JOIN " . TABLE_LANGUAGES . " l ON (pd.language_id = l.languages_id)
                              WHERE p.products_status = '1'
                              ORDER BY p.products_ordered desc";
      }
	if($query_name==1){
      $query_string = "SELECT c.categories_id,cd.categories_name,GREATEST(c.date_added, IFNULL(c.last_modified, 0)) AS last_date, l.code
                                FROM " . TABLE_CATEGORIES . " c
                                  LEFT JOIN " . TABLE_CATEGORIES_DESCRIPTION . " cd ON (cd.categories_id = c.categories_id)
                                  LEFT JOIN " . TABLE_LANGUAGES . " l ON (cd.language_id = l.languages_id)
                                WHERE c.categories_status = '1'
                                ORDER BY c.sort_order ASC, c.parent_id ASC, c.categories_id ASC";
      }
	  if($query_string!=''){
	  $audience = $db->Execute($query_string);
      $records = $audience->RecordCount();}
	  else{$records=0;}
      if ($records==0) {
        $messageStack->add("No Records Found.", 'error');
		var_dump($messageStack);

      } else { //process records
        $i=0;

        
     if($query_name==2){
        // add column headers if CSV format
          if ($format == "CSV" ) {
            $exporter_output .=  $LINESTART;
            $exporter_output .=  $FIELDSTART . "Name".$FIELDEND;
            $exporter_output .=  $FIELDSEPARATOR;
            $exporter_output .=  $FIELDSTART . "Links".$FIELDEND;
            $exporter_output .=  $LINEBREAK;
          
          

        // output real data
        while (!$audience->EOF) {
          $i++;

         
            $exporter_output .=  $LINESTART;
            $exporter_output .=  $FIELDSTART . $audience->fields['products_name'].$FIELDEND;
            $exporter_output .=  $FIELDSEPARATOR;
            $exporter_output .=  $FIELDSTART . get_link(zen_get_info_page($audience->fields['products_id']), 'products_id=' . $audience->fields['products_id'], 'NONSSL', false).$FIELDEND;
            $exporter_output .=  $LINEBREAK;
         
        $audience->MoveNext();
        }

           }
		   
		   // add column headers if txt format
          if ($format == "TXT" ) {
            
        while (!$audience->EOF) {
          $i++;

         
             $exporter_output .=  $LINESTART;
            $exporter_output .=  $FIELDSTART . get_link(zen_get_info_page($audience->fields['products_id']), 'products_id=' . $audience->fields['products_id'], 'NONSSL', false).'" title="'.$audience->fields['products_name'].'"'.$FIELDEND;
            $exporter_output .=  $audience->fields['products_name'];
            $exporter_output .=  $LINEBREAK;
         
        $audience->MoveNext();
        }

           }
		   
	   }   
	   
	   if($query_name==1){
        // add column headers if CSV format
          if ($format == "CSV" ) {
            $exporter_output .=  $LINESTART;
            $exporter_output .=  $FIELDSTART . "Name".$FIELDEND;
            $exporter_output .=  $FIELDSEPARATOR;
            $exporter_output .=  $FIELDSTART . "Links".$FIELDEND;
            $exporter_output .=  $LINEBREAK;
        // output real data
        while (!$audience->EOF) {
          $i++;  
            $exporter_output .=  $LINESTART;
            $exporter_output .=  $FIELDSTART . $audience->fields['categories_name'].$FIELDEND;
            $exporter_output .=  $FIELDSEPARATOR;
			//lightbox
            //$exporter_output .=  $FIELDSTART . get_link(FILENAME_DEFAULT, ($audience->fields['code'] != DEFAULT_LANGUAGE ? 'language=' . $categories->fields['code'] : "") . '&cPath='.$audience->fields['categories_id'], 'NONSSL', false).$FIELDEND;
			$exporter_output .=  $FIELDSTART . get_link(FILENAME_DEFAULT, ($audience->fields['code'] != DEFAULT_LANGUAGE ? 'language=' . $categories->fields['code'] : "") . '&cPath='.GetFullcPath($audience->fields['categories_id']), 'NONSSL', false).$FIELDEND;
            $exporter_output .=  $LINEBREAK;   
        $audience->MoveNext();
        }

           }
		   
		   // add column headers if txt format
          if ($format == "TXT" ) {
            
        while (!$audience->EOF) {
          $i++;
             $exporter_output .=  $LINESTART;
			 //lightbox
            //$exporter_output .=  $FIELDSTART .get_link(FILENAME_DEFAULT, ($audience->fields['code'] != DEFAULT_LANGUAGE ? 'language=' . $categories->fields['code'] : "") . '&cPath='.$audience->fields['categories_id'], 'NONSSL', false).'" title="'.$audience->fields['categories_name'].'"' .$FIELDEND;
			$exporter_output .=  $FIELDSTART .get_link(FILENAME_DEFAULT, ($audience->fields['code'] != DEFAULT_LANGUAGE ? 'language=' . $categories->fields['code'] : "") . '&cPath='.GetFullcPath($audience->fields['categories_id']), 'NONSSL', false).'" title="'.$audience->fields['categories_name'].'"' .$FIELDEND;
            $exporter_output .=  $audience->fields['categories_name'];
            $exporter_output .=  $LINEBREAK;
         
        $audience->MoveNext();
        }

           }
		   
	   }   
		   


    // theoretically, $i should == $records at this point.

      // status message
      $messageStack->add($records . " Processed.", 'success');

      // begin streaming file contents
      if ($save_to_file_checked != 1) { // not saving to a file, so do regular output
        if ($format == "CSV" || $format =="TXT" ) {
          
            $content_type = 'text/x-csv';
          
          if (preg_match('/MSIE/', $_SERVER['HTTP_USER_AGENT'])) {
            header('Content-Type: application/octetstream');
//            header('Content-Type: '.$content_type);
//              header('Content-Disposition: inline; filename="' . $file . '"');
            header('Content-Disposition: attachment; filename=' . $file);
            header("Expires: Mon, 26 Jul 2001 05:00:00 GMT");
            header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
            header("Cache-Control: must_revalidate, post-check=0, pre-check=0");
            header("Pragma: public");
            header("Cache-control: private");
          } else {
            header('Content-Type: application/x-octet-stream');
//            header('Content-Type: '.$content_type);
            header('Content-Disposition: attachment; filename=' . $file);
            header("Expires: Mon, 26 Jul 2001 05:00:00 GMT");
            header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
            header("Pragma: no-cache");
          }
          echo $exporter_output;
          exit;
        } else {
          echo $exporter_output;
          exit;
        }
      } else { //write to file
        //open output file for writing
        $f=fopen(DIR_FS_PRODUCT_LINKS_EXPORT.$file,'w');
        fwrite($f,$exporter_output);
        fclose($f);
        unset($f);
      } // endif $save_to_file
    } //end if $records for processing not 0

    zen_redirect(zen_href_link(FILENAME_PRODUCT_LINKS_EXPORT));
    break;

    }  //end switch / case

  }  //endif $action

?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<link rel="stylesheet" type="text/css" href="includes/cssjsmenuhover.css" media="all" id="hoverJS">
<script language="javascript" src="includes/menu.js"></script>
<script language="javascript" src="includes/general.js"></script>
<script type="text/javascript">
  <!--
  function init()
  {
    cssjsmenu('navbar');
    if (document.getElementById)
    {
      var kill = document.getElementById('hoverJS');
      kill.disabled = true;
    }
  }
  // -->
</script>
</head>
<body onLoad="init()">
<!-- header //-->
<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
<!-- header_eof //-->

<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE; ?></td>
            <td class="pageHeading" align="right"><?php echo zen_draw_separator('pixel_trans.gif', HEADING_IMAGE_WIDTH, HEADING_IMAGE_HEIGHT); ?></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo zen_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr><?php echo zen_draw_form('export', FILENAME_PRODUCT_LINKS_EXPORT, 'action=save','post');//, 'onsubmit="return check_form(export);"'); ?>
        <td align="center">
          <table border="0" cellspacing="0" cellpadding="2">
          <tr>
            <td class="main"><?php echo TEXT_PRODUCT_LINKS_EXPORT_FORMAT; ?><br />
<?php echo zen_draw_pull_down_menu('format', $available_export_formats, $format); ?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo zen_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
          <tr>
            <td class="main"><?php echo TEXT_PLEASE_SELECT_AUDIENCE; ?><br />
<?php 
$audiences_list=array(array('id'=>'','text'=>'Pleact Select'),array('id'=>'1','text'=>'Category Links'),array('id'=>'2','text'=>'Product Links'));

echo zen_draw_pull_down_menu('audience_selected', $audiences_list, $query_name)?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo zen_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
          <tr>
            <td class="main"><?php echo TEXT_PRODUCT_LINKS_EXPORT_FILENAME; ?><br />
<?php echo zen_draw_input_field('filename', $file); ?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo zen_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
          <tr>
            <td class="main"><?php echo TEXT_PRODUCT_LINKS_EXPORT_SAVETOFILE; ?><br />
<?php echo zen_draw_checkbox_field('savetofile', '1', $save_to_file_checked); 
      echo TEXT_PRODUCT_LINKS_EXPORT_DEST . ' ' .DIR_FS_PRODUCT_LINKS_EXPORT; ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo zen_image_submit('button_save.gif', IMAGE_SAVE) . '&nbsp;&nbsp;<a href="' . zen_href_link(FILENAME_DEFAULT) . '">' . zen_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>'; ?></td>
          </tr>
          <tr>
            <td class="main" colspan="2"><?php echo TEXT_INSTRUCTIONS; ?></td>
          </tr>
      </table></td>
    </form>
<!-- body_text_eof //-->
     </tr>
</table>
<!-- body_eof //-->

<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
<br />
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>